#include "Appevent.ch"
#include "Common.ch"
#include "OS.ch"
#include "xbp.ch"
#define XBP_LAYOUT_TEXTLEFT         (XBPALIGN_LEFT+XBPALIGN_HCENTER)
#define XBP_LAYOUT_TEXTTOP          (XBPALIGN_TOP+XBPALIGN_VCENTER)
#define XBP_LAYOUT_TEXTBOTTOM       (XBPALIGN_BOTTOM+XBPALIGN_HCENTER)
#define XBP_LAYOUT_TEXTRIGHT        (XBPALIGN_RIGHT+XBPALIGN_VCENTER)

#define OT4XB_MIN_VER "001.006.000.167"
#define _OT4XB_MAP_WAPIST_FUNC_
#include "ot4xb.ch"
#include "WinUser_constants.ch"
#include "CommCtrl_constants.ch"

PROCEDURE Main
LOCAL nEvent, mp1, mp2, oXbp
LOCAL lPimpIt := IF(PCOUNT()>0,.T.,.F.)
LOCAL nIcoX := 64
LOCAL nIcoY := 64
LOCAL aPos  := {0,0}
LOCAL aSize :=SetAppWindow():CurrentSize()

   SetColor("N/W")
   CLS

   aPos[1] := (aSize[1]/2)-(nIcoX  )-50
   aPos[2] := (aSize[2]/2)-(nIcoY/2)

   oXbp := RoundButton():new( , , aPos, {nIcoX,nIcoY} )
   oXbp:caption := "A"
   oXbp:PimpIt  := lPimpIt
   oXbp:nIconXSize := nIcoX
   oXbp:nIconYSize := nIcoY
   oXbp:create()

   oXbp:SetIcon(1000)                            // NORMAL
   oXbp:SetIcon(1001)                            // HOT
   oXbp:SetIcon(1002)                            // PUSHED
   oXbp:activate:= {|| QOut( "Pushbutton A" ) }

   aPos[1] := (aSize[1]/2)+50

   oXbp := RoundButton():new( , , aPos, {nIcoX,nIcoY} )
   oXbp:caption := "B"
   oXbp:PimpIt  := lPimpIt
   oXbp:nIconXSize := nIcoX
   oXbp:nIconYSize := nIcoY
   oXbp:create()

   oXbp:SetIcon(1000)
   oXbp:SetIcon(1001)
   oXbp:SetIcon(1002)
   oXbp:activate:= {|| QOut( "Pushbutton B" ) }

   nEvent := 0
   DO WHILE nEvent <> xbeP_Close
      nEvent := AppEvent( @mp1, @mp2, @oXbp )
      DO CASE
         CASE nEvent == xbeP_Keyboard .AND. mp1 == xbeK_ALT_F4
            EXIT
      OTHERWISE
         oXbp:HandleEvent( nEvent, mp1, mp2 )
      ENDCASE
   ENDDO

RETURN

*-------------------------------------------------------------------------*


CLASS RoundButton FROM XbpPushButton
HIDDEN:
   VAR hImageList                                // Handle Imagelist
   VAR hButton

EXPORTED:
   VAR PimpIt
   VAR nIconXSize
   VAR nIconYSize
   VAR cDllName
   VAR lIcoActive
   VAR TextAlign
   VAR Spaceing


INLINE METHOD Init( oParent, oOwner, aPos, aSize, aPP, lVisible )
   ::XbpPushButton:init( oParent, oOwner, aPos, aSize, aPP, lVisible )

   ::PimpIt       := .F.
   ::nIconXSize   := 16
   ::nIconYSize   := 16
   ::lIcoActive   := .F.
   ::hButton      := 0
   ::cDllName     := NIL
   ::TextAlign    := 0
   ::Spaceing     := 3

RETURN self

INLINE METHOD Create( oParent, oOwner, aPos, aSize, aPP, lVisible )
DEFAULT lVisible TO .T.

   ::XbpPushButton:Create( oParent, oOwner, aPos, aSize, aPP, lVisible )

   ::hButton := ::GetHwnd()

   IF ::PimpIt = .T.
      ::MachKreise()
   ENDIF

   ::hImageList := @comctl32:ImageList_Create( ;
             ::nIconXSize ,; // The width, in pixels, of each image
             ::nIconYSize ,; // The height, in pixels, of each image
             nOr(ILC_COLOR32,ILC_MASK/ILC_COLOR16,ILC_MASK) ,;
             1            ,; // The number of images that the image list initially contains.
             0   )           // This parameter represents the number of new images that the resized image list can contain

RETURN self

INLINE METHOD Destroy()
   IF .NOT. EMPTY(::hImageList)
      @comctl32:ImageList_Remove(::hImageList,-1)
      @comctl32:ImageList_Destroy(::hImageList)
   ENDIF

RETURN ::XbpPushButton:Destroy()

INLINE METHOD MachKreise()
LOCAL aTmp
LOCAL nLeftRect
LOCAL nTopRect
LOCAL nRightRect
LOCAL nBottomRect
LOCAL hRgn
LOCAL nFrame := @USER32:GetSystemMetrics(SM_CYBORDER)

   ::hide()

   aTmp  := ::Currentsize()

   nLeftRect   := 0       +nFrame
   nTopRect    := aTmp[2] -nFrame
   nRightRect  := aTmp[1] -nFrame
   nBottomRect := 0       +nFrame

   //
   // now construct a Region and call its API function
   //
   hRgn := @GDI32:CreateEllipticRgn(nLeftRect,nTopRect,nRightRect,nBottomRect)
   @User32:SetWindowRgn(::hButton,hRgn,.t.)

   IF .NOT. EMPTY(hRgn)
       @Gdi32:DeleteObject(hRgn)
   ENDIF

   ::show()

RETURN hRgn

INLINE METHOD SetIcon( xImage )
LOCAL nHICON
LOCAL nHandle
LOCAL nPosi
LOCAL hEXE := 0

   ::hide()

   IF ::lIcoActive = .F.
      ::_InitIconList()
   ENDIF

   IF VALTYPE( xImage ) = "O"

      IF xImage:isDerivedFrom( "DXE_Icon" )
         nHandle := xImage:Handle
         nHICON  := @USER32:CopyIcon( nHandle )

         @comctl32:ImageList_ReplaceIcon( ::hImageList, - 1, nHICON )

         IF OnOSVersion() < 6 // need for XP
            @User32:SendMessageA(::hButton,BM_SETIMAGE,IMAGE_ICON,nHICON)
         ENDIF

         @user32:DestroyIcon( nHICON )

      ENDIF

   ELSEIF VALTYPE( xImage ) = "C"
      IF FExists(xImage)

         nHICON := @user32:LoadImageA( hEXE, ;
                                    xImage+CHR(0), ;
                                    IMAGE_ICON   , ;
                                    ::nIconXSize , ;
                                    ::nIconYSize , ;
                                    nOr(LR_LOADFROMFILE ,LR_LOADTRANSPARENT) )

         @comctl32:ImageList_ReplaceIcon( ::hImageList, - 1, nHICON )

         IF OnOSVersion() < 6 // need for XP
            @User32:SendMessageA(::hButton,BM_SETIMAGE,IMAGE_ICON,nHICON)
         ENDIF

         @user32:DestroyIcon( nHICON )

      ENDIF

   ELSEIF VALTYPE( xImage ) = "N"

      hEXE := @KERNEL32:GetModuleHandleA( ::cDllName )
      //
      //
      //
      nHICON := @user32:LoadImageA( hEXE, ;
                                 MAKEINTRESOURCE( xImage ), ;
                                 IMAGE_ICON  , ;
                                 ::nIconXSize, ;
                                 ::nIconYSize, ;
                                 nOr( LR_SHARED,LR_LOADTRANSPARENT ) )

      @comctl32:ImageList_ReplaceIcon( ::hImageList, - 1, nHICON )

      IF OnOSVersion() < 6 // need for XP
         @User32:SendMessageA(::hButton,BM_SETIMAGE,IMAGE_ICON,nHICON)
      ENDIF

      @user32:DestroyIcon( nHICON )

   ENDIF

   ::show()

RETURN Self

INLINE METHOD _InitIconList()
LOCAL olist

   olist := BUTTON_IMAGELIST():NEW()

   olist:himl := ::hImageList

   DO CASE
      CASE ::TextAlign = XBP_LAYOUT_TEXTLEFT    ; olist:uAlign := BUTTON_IMAGELIST_ALIGN_RIGHT
      CASE ::TextAlign = XBP_LAYOUT_TEXTTOP     ; olist:uAlign := BUTTON_IMAGELIST_ALIGN_BOTTOM
      CASE ::TextAlign = XBP_LAYOUT_TEXTBOTTOM  ; olist:uAlign := BUTTON_IMAGELIST_ALIGN_TOP
      CASE ::TextAlign = XBP_LAYOUT_TEXTRIGHT   ; olist:uAlign := BUTTON_IMAGELIST_ALIGN_LEFT
   OTHERWISE
      olist:uAlign := BUTTON_IMAGELIST_ALIGN_CENTER
   ENDCASE

   DO CASE
      CASE ::TextAlign = XBP_LAYOUT_TEXTTOP     ; olist:margin:bottom := ::Spaceing
      CASE ::TextAlign = XBP_LAYOUT_TEXTBOTTOM  ; olist:margin:top    := ::Spaceing
      CASE ::TextAlign = XBP_LAYOUT_TEXTLEFT    ; olist:margin:right  := ::Spaceing
      CASE ::TextAlign = XBP_LAYOUT_TEXTRIGHT   ; olist:margin:left   := ::Spaceing
   ENDCASE

   @user32:SendMessageA(::hButton, BCM_SETIMAGELIST, 0, @olist)

   ::lIcoActive   := .T.

RETURN Self

ENDCLASS

*-------------------------------------------------------------------------*

STATIC FUNCTION OnOSVersion()
LOCAL cVersion := OS( OS_VERSION )
RETURN VAL(cVersion)

*
* eof
*
